Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| IAIK PKCS#11 Wrapper version 1.2.18
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## iaik.pkcs.pkcs11.objects
Class DHParams

    java.lang.Object
      |
      +--iaik.pkcs.pkcs11.objects.Object
            |
            +--iaik.pkcs.pkcs11.objects.Storage
                  |
                  +--iaik.pkcs.pkcs11.objects.DomainParameters
                        |
                        +--iaik.pkcs.pkcs11.objects.DHParams

All Implemented Interfaces:
  java.lang.Cloneable

Direct Known Subclasses:
  X942DHParams

public class DHParams
extends DomainParameters

Objects of this class represent DH domain parameters as specified by PKCS#11 v2.11.

Version:
  1.0
Author:
  Karl Scheibelhofer

Inner classes inherited from class iaik.pkcs.pkcs11.objects.DomainParameters
`DomainParameters.VendorDefinedDomainParametersBuilder`

Inner classes inherited from class iaik.pkcs.pkcs11.objects.Object
`Object.ObjectClass, Object.VendorDefinedObjectBuilder`

Field Summary
`protected ByteArrayAttribute` | `base_` The base (g) of this DH key.
`protected ByteArrayAttribute` | `prime_` The prime (p) of this DH key.
`protected LongAttribute` | `primeBits_` The length of the prime value in bits.

Fields inherited from class iaik.pkcs.pkcs11.objects.DomainParameters
`keyType_, local_, vendorDomainParametersBuilder_`

Fields inherited from class iaik.pkcs.pkcs11.objects.Storage
`label_, modifiable_, private_, token_`

Fields inherited from class iaik.pkcs.pkcs11.objects.Object
`attributeTable_, objectClass_, objectClassNames_, objectHandle_, vendorObjectBuilder_`

Constructor Summary
`` | `DHParams()` Deafult Constructor.
`protected` | `DHParams(Session session, long objectHandle)` Called by getInstance to create an instance of a PKCS#11 DH private key.

Method Summary
`protected void` | `allocateAttributes()` Allocates the attribute objects for this class and adds them to the attribute table.
`java.lang.Object` | `clone()` Create a (deep) clone of this object.
`boolean` | `equals(java.lang.Object otherObject)` Compares all member variables of this object with the other object.
`ByteArrayAttribute` | `getBase()` Gets the base attribute of this DH key.
`static Object` | `getInstance(Session session, long objectHandle)` The getInstance method of the PrivateKey class uses this method to create an instance of a PKCS#11 DH private key.
`ByteArrayAttribute` | `getPrime()` Gets the prime attribute of this DH key.
`LongAttribute` | `getPrimeBits()` Gets the value length of the prime (in bits).
`protected static void` | `putAttributesInTable(DHParams object)` Put all attributes of the given object into the attributes table of this object.
`void` | `readAttributes(Session session)` Read the values of the attributes of this object from the token.
`java.lang.String` | `toString()` This method returns a string representation of the current object.

Methods inherited from class iaik.pkcs.pkcs11.objects.DomainParameters
`getKeyType, getUnknownDomainParameters, getVendorDefinedDomainParametersBuilder, hashCode, isLocal, putAttributesInTable, setVendorDefinedDomainParametersBuilder`

Methods inherited from class iaik.pkcs.pkcs11.objects.Storage
`getLabel, getModifiable, getPrivate, getToken, putAttributesInTable`

Methods inherited from class iaik.pkcs.pkcs11.objects.Object
`getAttributeTable, getAttributeValue, getAttributeValues, getObjectClass, getObjectClassName, getObjectHandle, getSetAttributes, getSetAttributes, getUnknownObject, getVendorDefinedObjectBuilder, putAttributesInTable, setObjectHandle, setVendorDefinedObjectBuilder`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### prime_

    protected ByteArrayAttribute prime_

  The prime (p) of this DH key.

### base_

    protected ByteArrayAttribute base_

  The base (g) of this DH key.

### primeBits_

    protected LongAttribute primeBits_

  The length of the prime value in bits.

Constructor Detail

### DHParams

    public DHParams()

  Deafult Constructor.

### DHParams

    protected DHParams(Session session,
                       long objectHandle)
                throws TokenException

  Called by getInstance to create an instance of a PKCS#11 DH private key.
  Parameters:
    `session` - The session to use for reading attributes. This session must have the appropriate rights; i.e. it must be a user-session, if it is a private object.
    `objectHandle` - The object handle as given from the PKCS#111 module.
  Throws:
    `TokenException` - If getting the attributes failed.

Method Detail

### getInstance

    public static Object getInstance(Session session,
                                     long objectHandle)
                              throws TokenException

  The getInstance method of the PrivateKey class uses this method to create an instance of a PKCS#11 DH private key.
  Parameters:
    `session` - The session to use for reading attributes. This session must have the appropriate rights; i.e. it must be a user-session, if it is a private object.
    `objectHandle` - The object handle as given from the PKCS#111 module.
  Returns:
    The object representing the PKCS#11 object. The returned object can be casted to the according sub-class.
  Throws:
    `TokenException` - If getting the attributes failed.

### putAttributesInTable

    protected static void putAttributesInTable(DHParams object)

  Put all attributes of the given object into the attributes table of this object. This method is only static to be able to access invoke the implementation of this method for each class separately (see use in clone()).
  Parameters:
    `object` - The object to handle.

### allocateAttributes

    protected void allocateAttributes()

  Allocates the attribute objects for this class and adds them to the attribute table.
  Overrides:
    `allocateAttributes` in class `DomainParameters`

### clone

    public java.lang.Object clone()

  Create a (deep) clone of this object.
  Overrides:
    `clone` in class `DomainParameters`
  Returns:
    A clone of this object.

### equals

    public boolean equals(java.lang.Object otherObject)

  Compares all member variables of this object with the other object. Returns only true, if all are equal in both objects.
  Overrides:
    `equals` in class `DomainParameters`
  Parameters:
    `otherObject` - The other object to compare to.
  Returns:
    True, if other is an instance of this class and all member variables of both objects are equal. False, otherwise.

### getPrime

    public ByteArrayAttribute getPrime()

  Gets the prime attribute of this DH key.
  Returns:
    The prime attribute.

### getBase

    public ByteArrayAttribute getBase()

  Gets the base attribute of this DH key.
  Returns:
    The base attribute.

### getPrimeBits

    public LongAttribute getPrimeBits()

  Gets the value length of the prime (in bits).
  Returns:
    The prime bits attribute.

### readAttributes

    public void readAttributes(Session session)
                        throws TokenException

  Read the values of the attributes of this object from the token.
  Overrides:
    `readAttributes` in class `DomainParameters`
  Parameters:
    `session` - The session handle to use for reading attributes. This session must have the appropriate rights; i.e. it must be a user-session, if it is a private object.
  Throws:
    `TokenException` - If getting the attributes failed.

### toString

    public java.lang.String toString()

  This method returns a string representation of the current object. The output is only for debugging purposes and should not be used for other purposes.
  Overrides:
    `toString` in class `DomainParameters`
  Returns:
    A string presentation of this object for debugging output.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| IAIK PKCS#11 Wrapper version 1.2.18
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

IAIK JavaSecurity Website http://jce.iaik.tugraz.at/
IAIK at Graz University of Technology, Austria, Europe
Copyright 2001-2004, IAIK, Graz University of Technology, Inffeldgasse 16a, 8010 Graz, Austria. All Rights Reserved. version 1.2.18